from fastapi.testclient import TestClient

from fimportal.xdatenfelder import xdf2, xdf3
from tests.conftest import CommandRunner
from tests.factories.xdf2 import Xdf2Factory
from tests.factories.xdf3 import Xdf3Factory


def test_should_return_the_group_in_xdf2_form(
    runner: CommandRunner, client: TestClient
):
    factory = Xdf2Factory()
    message = factory.group().full().message()
    factory.schema().with_group(message.group).save(runner)

    response = client.get(
        f"/api/v1/groups/baukasten/{message.id}/{message.version}/xdf"
    )

    assert response.status_code == 200
    assert response.headers["content-type"] == "application/xml"
    assert (
        response.headers["content-disposition"]
        == f'attachment; filename="{message.id}V{message.version}.xdf2.xml"'
    )

    parsed_message = xdf2.parse_datenfeldgruppe_message(response.read())

    # Patch the message header, as this is generated by the server and not part of the actual data.
    parsed_message.header = message.header

    assert parsed_message == message


def test_should_return_the_group_in_xdf3_form(
    runner: CommandRunner, client: TestClient
):
    factory = Xdf3Factory()
    message = factory.group().full().message()
    factory.schema().with_group(message.group).save(runner)

    response = client.get(
        f"/api/v1/groups/baukasten/{message.id}/{message.version}/xdf"
    )

    assert response.status_code == 200
    assert response.headers["content-type"] == "application/xml"
    assert (
        response.headers["content-disposition"]
        == f'attachment; filename="{message.id}V{message.version}.xdf3.xml"'
    )

    parsed_message = xdf3.parse_datenfeldgruppe_message(response.read())

    # Patch the message header, as this is generated by the server and not part of the actual data.
    parsed_message.header = message.header

    assert parsed_message == message


def test_should_work_with_latest(runner: CommandRunner, client: TestClient):
    factory = Xdf2Factory()
    group = factory.group().full().build()
    factory.schema().with_group(group).save(runner)

    response = client.get(f"/api/v1/groups/baukasten/{group.identifier.id}/latest/xdf")

    assert response.status_code == 200
    assert response.headers["content-type"] == "application/xml"
    assert (
        response.headers["content-disposition"]
        == f'attachment; filename="{group.identifier.id}V{group.identifier.version}.xdf2.xml"'
    )


def test_should_fail_for_unknown_group(client: TestClient):
    response = client.get("/api/v1/groups/baukasten/G123456/1.0/xdf")

    assert response.status_code == 404
    assert response.json() == {
        "detail": "Could not find group G123456V1.0 in namespace baukasten."
    }
